/* This currently is a rip of altpw.c and the pw* has basically been made
	gr*.  I consider that a bug, and it will change someday.  */

#include <stdio.h>
#include <stdlib.h>
#include <grp.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

#ifdef ENABLE_SYSLOG
#include <syslog.h>

#define	SYSLOG(x)	syslog( LOG_DEBUG, x )
#define	SYSLOG2(x,y)	syslog( LOG_DEBUG, x, y )

#else

#define	SYSLOG(x)	/* */
#define	SYSLOG2(x,y)	/* */

#endif

#define GETGR_NAMELEN 	255

char	GETGR_PWFILENAME[ GETGR_NAMELEN ] = "/etc/group";
FILE	*GETGR_PWFILEDESC;

/* The only real function I made.  :) */
void	getpr_setaltfile( const char *file )
{
	strcpy( GETGR_PWFILENAME, file );

	/* If the old file is open, then close it */
	if( GETGR_PWFILEDESC != NULL )
	{
		fclose( GETGR_PWFILEDESC );
		GETGR_PWFILEDESC = NULL;
	}
}

/* All the replacement funcs follow here */
struct group *getgrent(void)
{
#ifdef ENABLE_SYSLOG
	struct group	*pw;
#endif
	char	*envpw;
	char	*bin, *buf, *fpath;

	FILE	*conf;

	if( GETGR_PWFILEDESC == NULL )
	{
		/* If the ALTGROUP env is set, use it always */
		envpw = getenv( "ALTGROUP" );
		if( envpw != NULL )
		{
#ifdef ENABLE_PARANOID
			/* Validate that we are uid 0 */
			if( getuid() != 0 )
			{
				SYSLOG2( "Override attempted by non-root UID %d", getuid() );
				strcpy( GETGR_PWFILENAME, "/etc/group" );
			}
#endif
			strcpy( GETGR_PWFILENAME, envpw );
		}else
		{
			/* Otherwise, use /etc/group.switch */
			bin = (char *)malloc( 1024 );
			buf = (char *)malloc( 1024 );
			bzero( bin, 1024 );
			readlink( "/proc/self/exe", bin, 1023 );

			/* Now go through the config to resolve... */
			conf = fopen( "/etc/group.switch", "r" );
			if( conf )
			{
				while( conf )
				{
					if( fgets( buf, 1024, conf ) )
					{
						/* Clean any \n */
						if( buf[ strlen( buf ) - 1 ] == '\n' )
						{
							buf[ strlen( buf ) - 1 ] = 0;
						}

						fpath = strchr( buf, ':' );
						SYSLOG2( "Line read: %s", buf );

						if( fpath )
						{
							/* Null it here */
							*fpath = 0;
	
							/* Move to beg of string */
							fpath++;

							SYSLOG2( "buf: %s", buf );
							SYSLOG2( "fpath: %s", fpath );

							/* Check if stuff before : is in bin filename */
							if( ( strcmp( buf, "*" ) == 0 ) ||
								( strstr( bin, buf ) ) )
							{
								/* Match! */
								SYSLOG2( "Match for group file: %s", fpath );
								strcpy( GETGR_PWFILENAME, fpath );
								fclose( conf );
								conf = NULL;
							}
						}
					}else
					{
						SYSLOG( "No match found in /etc/group.switch for file" );
						fclose( conf );
						conf = NULL;
					}
				}
			}else
			{
				SYSLOG( "Unable to open: /etc/group.switch, USING DEFAULT GROUP FILE" );
			}

			free( bin );
			free( buf );

			if( GETGR_PWFILENAME[ 0 ] == 0 )
			{
				printf( "Unable to locate a group file, bye now.\n" );
				exit( 0 );
			}
		}


		/* Need to open it first */
		GETGR_PWFILEDESC = fopen( GETGR_PWFILENAME, "r" );
		if( ! GETGR_PWFILEDESC )
		{
			printf( "Could not open file: '%s'\n", GETGR_PWFILENAME );
			exit( 1 );
		}

		SYSLOG2( "Opened grfile '%s'", GETGR_PWFILENAME );
	}

#ifdef ENABLE_SYSLOG
	pw = fgetgrent( GETGR_PWFILEDESC );

	if( pw == NULL )
	{
		SYSLOG( "Got NULL ptr" );
	}else
	{
		SYSLOG2( "Got groupname: '%s'", pw -> gr_name );
	}

	return( pw );
#else
	return( fgetgrent( GETGR_PWFILEDESC ) );
#endif
}

void	setgrent( void )
{
	/* Rewind the ptr */
	if( GETGR_PWFILEDESC != NULL )
	{
		/* Just for now, this will reset it since it will re-open it */
		fclose( GETGR_PWFILEDESC );
		GETGR_PWFILEDESC = NULL;
	}
}

void	endgrent( void )
{
	setgrent();
}

struct group *getgrnam(const char * name)
{
	struct group	*pw;

	/* Rewind */
	setgrent();

	/* Now scan on through... */
	while( 1 )
	{
		pw = getgrent();

		if( ( pw == NULL ) ||
			( strcmp( name, pw -> gr_name ) == 0 ) )
		{
			return( pw );
		}
	}
}

struct group *getgrgid(gid_t gid)
{
	struct group	*pw;

	/* Rewind */
	setgrent();

	/* Now scan on through... */
	while( 1 )
	{
		pw = getgrent();

		if( ( pw == NULL ) ||
			( gid == pw -> gr_gid ) )
		{
			return( pw );
		}
	}
}

